<?php
if (strstr($_SERVER["PHP_SELF"], "/modules/"))  die ("You can't access this file directly...");

function forum_list_topics()
{
        global $config, $lang, $cfg;
        $muid=$_SESSION["wt"]["uid"];
        if( !isset($_GET["forum"])) return;
        $forum_cod = intval($_GET["forum"]);

        $fpage = 0;
        if( isset($_GET["fpage"]) ) $fpage = intval($_GET["fpage"]);
        if( $fpage <= 0 ) $fpage = 1;

        $stmt = "select * from {$config["prefix"]}_forums where cod=$forum_cod";
        if( !($ret = db_query($stmt)) ) {
                print $lang["ERROR_04"].": ".db_error();
                return;
        }
        $forum = db_fetch_array($ret);
        db_free_result($ret);
        if( !$forum ) return;

        // if this is a private forum, lets see if the user has the permission
        if( $forum["locked"] == "Y" ) {
                if( !forum_user_allowed( $forum["cod"] ) ) {
                        print "<span class=\"error\">{$lang["FORUM_LOCKED"]}</div>";
                        return;
                }
        }
        theme_draw_centerbox_open( $lang["FORUM_TITLE"]." - ".$forum["title"] );

        $stmt = "SELECT cod, title, userid, date, views, closed, sticky FROM {$config["prefix"]}_forum_msgs WHERE msg_ref = 0 AND forum = {$forum["cod"]} order by sticky DESC, date_der DESC";
        switch ( $config["dbtype"] ) {
                case "mysql":
                        $stmt .= " LIMIT ".(($fpage-1)*$cfg["forum"]["nbtopic"]).", ".$cfg["forum"]["nbtopic"];
                        break;
                case "pgsql":
                        $stmt .= " LIMIT ".$cfg["forum"]["nbtopic"]." OFFSET ".(($fpage-1)*$cfg["forum"]["nbtopic"]);
        }
        if( !$ret = db_query($stmt) ) {
                print $lang["ERROR_04"].": ".db_error();
                theme_draw_centerbox_close();
                return;
        }

        forum_topics_header($forum_cod);
        $ntopics = 0;
        while( $topic = db_fetch_array($ret) ) {

                $stmt = "SELECT COUNT(*) AS qtde FROM {$config['prefix']}_forum_msgs WHERE msg_ref={$topic["cod"]}";
                if( !($ret2 = db_query($stmt)) ) {
                        print $lang["ERROR_04"].":".db_error();
                        theme_draw_centerbox_close();
                        return;
                }
                $tcount = db_result($ret2,0,0);
                db_free_result($ret2);
                $mtime=0;
                if( $tcount > 0 ) {
                        $stmt = "SELECT userid, date, cod FROM {$config['prefix']}_forum_msgs WHERE msg_ref={$topic["cod"]} order by date desc limit 0,1";
                        if( !($ret2 = db_query($stmt)) ) {
                                print $lang["ERROR_04"].":".db_error();
                                theme_draw_centerbox_close();
                                return;
                        }
                        $lmsg = db_fetch_array($ret2);
                        db_free_result($ret2);

                } else {
                        $lmsg = array( "userid"=>$topic["userid"], "date"=>$topic["date"], "cod"=>$topic["cod"] );
                }
                $result=db_query("SELECT logtime from {$config['prefix']}_forum_log_topics where msgid={$topic["cod"]} and uid=$muid");
                if (db_num_rows($result)>0)
                {
                  $row=db_fetch_array($result);
                  $ltdate=$row["logtime"];
                  db_free_result($result);
                }
                else $ltdate=0;
                $author = getNameById($lmsg["userid"]);
                if( $topic["closed"] == "Y" ) {
                    if ( $topic["sticky"] == "1" ) $pic = "modules/forum/images/lockedsticky.gif";
                    else $pic = "modules/forum/images/folder_locked.gif";
                }
                else if ( $topic["sticky"] == "1" ) $pic = "modules/forum/images/sticky.gif";
                else $pic = "modules/forum/images/folder.gif";
                $class = sprintf( "class=\"row%d\"", ($ntopics++%2)+1 );
                print "<tr><td align=\"center\" valign=\"middle\" $class><img src=\"$pic\" border=\"0\" alt=\"\" align=\"middle\"></td>"
                        ."<td valign=\"middle\" $class>"
                        ."<a href=\"forum.php?forum={$forum["cod"]}&fpage=$fpage&msg={$topic["cod"]}\">{$topic["title"]}</a>";
                $lmdate=mktime(substr($lmsg["date"],11,2),substr($lmsg["date"],14,2),substr($lmsg["date"],17,2),
                        substr($lmsg["date"],5,2),substr($lmsg["date"],8,2),substr($lmsg["date"],0,4));
                if (($lmdate>$ltdate) and $_SESSION["wt"]["logged"]){
                   if ($ltdate>0)
                   {
                    $zdate=date("Y-m-d H:i:s",$ltdate);
                    $result=db_query("SELECT date, cod from {$config['prefix']}_forum_msgs where (msg_ref={$topic["cod"]} or cod={$topic["cod"]}) and date>'$zdate' order by date asc limit 0,1");
                    if (db_num_rows($result)>0)
                    {
                       $row1=db_fetch_array($result);
                       $anch=$row1["cod"];
                       db_free_result($result);
                    }

                   }
                   else
                   {
                       $anch=$topic["cod"];
                   }

                   echo "&nbsp;<a href=\"forum.php?forum={$forum["cod"]}&fpage=$fpage&msg={$topic["cod"]}&msgref=$anch#anch$anch\"><img src=\" modules/forum/images/{$cfg["core"]["lang"]}/new.gif\" border=\"0\"  align=\"middle\"></a>";
                }
                if ($tcount+1>$cfg["forum"]["nbmess"])
                {
                  $linkstr="&nbsp;&nbsp;<font size=\"1\">[";
                  $pages=ceil(($tcount+1)/$cfg["forum"]["nbmess"]);
                  for ($i=1;$i<=$pages;$i=$i+1)
                  {
                   $linkstr=$linkstr."&nbsp;<a href=\"forum.php?msg={$topic["cod"]}&forum={$forum["cod"]}&page=$i&fpage=$fpage\"><font size=\"1\">$i</font></a>";
                  }
                  echo $linkstr."&nbsp;]</font>";


                }
                        print "</td>"
                        ."<td align=\"right\" valign=\"top\" $class>{$topic["views"]} / {$tcount}</td>"
                        ."<td align=\"right\" valign=\"top\" $class>".show_date($lmsg["date"],true)."<br>";
                if( $lmsg["userid"] > 0 ) {
                        print "<a href=\"user.php?uid={$lmsg["userid"]}\">$author</a>";
                } else {
                        print "$author";
                }
                print "</td></tr>";
        }
        db_free_result($ret);
        forum_topics_footer($forum_cod);

    //Calculating the number of pages
        $stmt = "select count(*) from {$config["prefix"]}_forum_msgs where msg_ref=0 and forum={$forum["cod"]}";
        if( !($ret = db_query($stmt)) ) {
                print $lang["ERROR_04"].": ".db_error();
                return;
        }
        $total = db_result($ret,0,0);
        db_free_result($ret);

        echo "<br><table width=80 border=0 cellspacing=0 cellpadding=2 align=\"center\"><tr>";
        if( $fpage > 1 ) {
                print "<td width=20 align=\"center\">"
                        ."<a href=\"forum.php?forum={$forum["cod"]}&fpage=1\"><img src=\"modules/forum/images/navbar_r1_c1.png\" width=16 height=16 alt=\"\" border=0></a></td>"
                        ."<td width=20 align=\"center\">"
                        ."<a href=\"forum.php?forum={$forum["cod"]}&fpage=".($fpage-1)."\"><img src=\"modules/forum/images/navbar_r1_c2.png\" width=16 height=16 alt=\"\" border=0></a></td>";
        } else {
                print "<td width=20 align=\"center\"><img src=\"modules/forum/images/navbar_r1_c1.png\" width=16 height=16 alt=\"\" border=0></td>"
                        ."<td width=20 align=\"center\"><img src=\"modules/forum/images/navbar_r1_c2.png\" width=16 height=16 alt=\"\" border=0></td>";
        }

        $lpage = ceil($total / $cfg["forum"]["nbtopic"]);
        if( $fpage < $lpage ) {
                print "<td width=20 align=\"center\">"
                        ."<a href=\"forum.php?forum={$forum["cod"]}&fpage=".($fpage+1)."\"><img src=\"modules/forum/images/navbar_r1_c3.png\" width=16 height=16 alt=\"\" border=0></a></td>"
                        ."<td width=20 align=\"center\">"
                        ."<a href=\"forum.php?forum={$forum["cod"]}&fpage=$lpage\"><img src=\"modules/forum/images/navbar_r1_c4.png\" width=16 height=16 alt=\"\" border=0></a></td>";
        } else {
                print "<td width=20 align=\"center\"><img src=\"modules/forum/images/navbar_r1_c3.png\" width=16 height=16 alt=\"\" border=0></td>"
                        ."<td width=20 align=\"center\"><img src=\"modules/forum/images/navbar_r1_c4.png\" width=16 height=16 alt=\"\" border=0></td>";
        }
        print "</tr></table>";
        print "<a href=\"forum.php\">{$lang["FORUM_GOUP"]}</a><br>";
        theme_draw_centerbox_close();
//        forum_write_form( $forum["cod"], $fpage, 0, "" );
}

function forum_topics_header($forum_cod)
{
        global $lang, $cfg;
?>
<table width="100%" cellspacing="0" cellpadding="2" border=0>
<tr>
        <td width="16" height="1"><img src="images/shim.gif" width="16" height="1" alt="" border="0"></td>
        <td width="100%" height="1"><img src="images/shim.gif" width="100%" height="1" alt="" border="0"></td>
        <td width="40" height="1"><img src="images/shim.gif" width="40" height="1" alt="" border="0"></td>
        <td width="100" height="1"><img src="images/shim.gif" width="100" height="1" alt="" border="0"></td>
</tr>
<?php
  if( $_SESSION["wt"]["logged"] or $cfg["forum"]["allow_anonymous"])
  {	
?>
<tr>
<td colspan="4" height="40" valign="middle" align="right"><a href="forum.php?act=new&forum=<?php echo $forum_cod; ?>"><img src="modules/forum/images/<?php echo $cfg["core"]["lang"]; ?>/new_thread.gif" border="0"></a></td>
</tr>
<?php
  }
?>
<tr>
        <td class="row0">&nbsp;</td>
        <td class="row0"><?php print $lang["FORUM_HEADER_TOPICS"]; ?></td>
        <td class="row0" align="right"><?php print $lang["FORUM_HEADER_VR"]; ?></td>
        <td class="row0" align="right"><?php print $lang["FORUM_HEADER_LASTPOST"]; ?></td>
</tr>
<?php
}

function forum_topics_footer($forum_cod)
{
 global $cfg;
  if( $_SESSION["wt"]["logged"] or $cfg["forum"]["allow_anonymous"])
  {	
?>
<tr>
<td colspan="4" height="40" valign="middle" align="right"><a href="forum.php?act=new&forum=<?php echo $forum_cod; ?>"><img src="modules/forum/images/<?php echo $cfg["core"]["lang"]; ?>/new_thread.gif" border="0"></a></td>
</tr>
<?php
  }
        echo "</table>";
}
?>
